program World3D;

uses Dos, Graph, Crt;

const ANGLE_0   = 0;
const ANGLE_90  = 480;
const ANGLE_180 = 960;
const ANGLE_270 = 1440;
const ANGLE_360 = 1920;

var Data1: Pointer;
    Data2: Pointer;
    Map: array[1..32, 1..32] of Byte;
    Pal: array[0..1023] of Byte;
    TanTable: array[1..1920] of Extended;
    CosTable: array[1..320] of Extended;
    TexOff, TexFlag: Integer;
    In_, Out: Text;

    Key: Byte;
    xp, yp, tx, ty: Integer;
    Angle_P, Angle: Integer;
    D, M, gd, gm: Integer;
    L, R, F, B: Integer;
    InFlag, OutFlag, i, j: Integer;

function Dist(A: Integer; x_p, y_p: Word): Integer;
  var X, Y, M, X_Dist, Y_Dist, X_, Y_: Extended;
begin
  X := x_p;
  Y := y_p;
  X_ := x_p;
  Y_ := y_p;

  if A = ANGLE_0 then A := ANGLE_0 + 1;
  if A = ANGLE_90 then A := ANGLE_90 + 1;
  if A = ANGLE_180 then A := ANGLE_180 + 1;
  if A = ANGLE_270 then A := ANGLE_270 + 1;
  if A = ANGLE_360 then A := ANGLE_360 - 1;

  if (A < ANGLE_90) or (A > ANGLE_270 + 1) then
  begin
    M := 128 * TanTable[A + 1];
    X := Int(X / 128) * 128 + 128;
    Y := Y + (x_p - X) * TanTable[A + 1];
    while (Map[Trunc(X / 128) + 1][Trunc(Y / 128) + 1] = 0) and (Y > 0) and (Y < 4096) and (X < 4096) do
    begin
      X := X + 128;
      Y := Y - M;
    end;
  end
  else
  if (A > ANGLE_90) and (A < ANGLE_270 - 1) then
  begin
    M := 128 * TanTable[A + 1];
    X := Int(X / 128) * 128;
    Y := Y + (x_p - X) * TanTable[A + 1];
    while (Map[Trunc((X - 128) / 128) + 1][Trunc(Y / 128) + 1] = 0) and (y > 0) and (x > 0) and (y < 4096) do
    begin
      X := X - 128;
      Y := Y + M;
    end;
  end;
  X_Dist := Sqrt(Sqr(X - x_p) + Sqr(Y - y_p));

  if (A > ANGLE_180) and (A < ANGLE_360) and (TanTable[A] <> 0) then
  begin
    M := 128 / TanTable[A + 1];
    Y_ := Int(Y_ / 128) * 128 + 128;
    X_ := X_ + (y_p - Y_) / TanTable[A + 1];
    while (Map[Trunc(X_ / 128) + 1][Trunc(Y_ / 128) + 1] = 0) and (X_ > 0) and (X_ < 4096) and (Y_ < 4096) do
    begin
      Y_ := Y_ + 128;
      X_ := X_ - M;
    end;
  end
  else
  if (A > ANGLE_0) and (A < ANGLE_180) and (TanTable[A] <> 0) then
  begin
    M := 128 / TanTable[A];
    Y_ := Int(Y_ / 128) * 128;
    X_ := X_ + (y_p - Y_) / TanTable[A];
    while (Map[Trunc(X_ / 128) + 1][Trunc((Y_ - 128) / 128) + 1] = 0) and (X_ > 0) and (Y_ > 0) and (X_ < 4096) do
    begin
      Y_ := Y_ - 128;
      X_ := X_ + M;
    end;
  end;
  Y_Dist := Sqrt(Sqr(X_ - x_p) + Sqr(Y_ - y_p));

  if (X_Dist < Y_Dist) and (X_Dist <> 0) then
  begin
    TexOff := Trunc(Y) mod 128;
    TexFlag := 0;
    Dist := Trunc(X_Dist);
  end
  else
  if (Y_Dist < X_Dist) and (Y_Dist <> 0) then
  begin
    TexOff := Trunc(X_) mod 128;
    TexFlag := 1;
    Dist := Trunc(Y_Dist);
  end
  else
    Dist := D;
end;

procedure FillTables;
  var Angle: Extended;
      i: Integer;
begin
  Angle := 0;

  for i := 1 to 1920 do
  begin
    if (Cos(Angle * Pi / 180) <> 0) and (Angle <> ANGLE_90) then
      TanTable[i] := Sin(Angle * Pi / 180) / Cos(Angle * Pi / 180);
    Angle := Angle + 0.1875;
  end;

  for i := 1 to 320 do
    CosTable[i] := Cos((i * 0.1875 - 30) * Pi / 180);
end;

procedure SetMode(Mode: Word);
begin
  asm
      mov    ax,  Mode
      int    10h
  end;
end;

procedure SetRGB(n, R, G, B: Byte);
begin
  asm
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  R
      shr    al,  2
      out    dx,  al
      mov    al,  G
      shr    al,  2
      out    dx,  al
      mov    al,  B
      shr    al,  2
      out    dx,  al
  end;
end;

procedure SetPal;
  var i: Integer;
begin
  for i := 1 to 255 do
    SetRGB(i, Pal[i * 4 + 2], Pal[i * 4 + 1], Pal[i * 4]);
end;

procedure PutLine(X, From, To_: Integer; C1: Byte; Off, M: Integer);
  var C: Byte;
begin
  C := 128;
  asm
      push   ds
      cmp    TexFlag,   0
      jz     @@4
      lds    si,  Data1
      jmp @@5
@@4:  lds    si,  Data2
@@5:  mov    ax,  0A000h
      mov    es,  ax
      mov    di,  X
      mov    cx,  200
@1:   mov    al,  C
      shr    al,  3
      add    al,  C1
      cmp    cx,  from
      jb     @2
      cmp    cx,  To_
      ja     @2
      xor    dx,  dx
      mov    ax,  32512
      mov    bx,  M
      div    bx
      mov    bx,  200
      sub    bx,  cx
      cmp    from, 0
      jnz    @@3
      push   cx
      mov    cx,  M
      sub    cx,  200
      shr    cx,  1
      add    bx,  cx
      pop    cx
@@3:  sub    bx,  From
      mul    bx
      shr    ax,  8
      shl    ax,  7
      add    ax,  Off
      add    ax,  4
      mov    si,  ax
      mov    al,  ds:[si]
@2:   stosb
      add    di,  319
      cmp    C,   0
      jz     @@7
      dec    C
@@7:  loop   @1
      pop    ds
  end;
end;

procedure Load;
  var In_: File;
      T: Text;
      i, j: Integer;
      S: String;
begin
  j := 1;

  GetMem(Data1, 16384);
  GetMem(Data2, 16384);

  Assign(In_, '059-013.bmp');
  Reset(In_, 1);
  Seek(In_, 54);
  BlockRead(In_, Pal, 1024);
  BlockRead(In_, Data1^, 16384);
  Close(In_);
  Assign(In_, '058-013.bmp');
  Reset(In_, 1);
  Seek(In_, 1078);
  BlockRead(In_, Data2^, 16384);
  Close(In_);
  Assign(T, 'map.txt');
  Reset(T);

  repeat
    Readln(T, S);
    for i := 1 to Length(S) do
      case S[i] of
        '*': Map[i][j] := 1;
        ' ': Map[i][j] := 0;
      end;
    Inc(j);
  until Eof(T);

  Close(T);
end;

procedure PrintHelp;
begin
  Writeln;
  Writeln('3D World. Version 1.5.');
  Writeln('Copyright (c) 1999 by MATI Inc.');
  Writeln;
  Writeln('     Usage: 3DWORLD [options <files>]');
  Writeln;
  Writeln('Options:');
  Writeln('     -r  Record demo to <filename>');
  Writeln('     -p  Play demo from <filename>');
end;

procedure CheckCommandLine(Argc: Integer; Argv1, Argv2: String);
  var i: Integer;
begin
  for i := 1 to Length(Argv1) do
    Argv1[i] := UpCase(Argv1[i]);
  for i := 1 to Length(Argv2) do
    Argv2[i] := UpCase(Argv2[i]);

  InFlag := 0;
  OutFlag := 0;

  if Argc >= 2 then
  begin
    if Argv1 = '-R' then
    begin
      {$I-}
      Assign(Out, Argv2);
      Reset(Out);
      if (IOResult <> 0) or (Argc < 3) then
      begin
        Writeln('Unable to open demo file');
        Halt(1);
      end;
      {$I+}
      OutFlag := 1;
    end
    else
    if Argv1 = '-P' then
    begin
      {$I-}
      Assign(In_, Argv2);
      Reset(In_);
      if (IOResult <> 0) or (Argc < 3) then
      begin
        Writeln('Unable to open demo file');
        Halt(1);
      end;
      {$I+}
      InFlag := 1;
    end
    else
    if Argv1 = '-?' then
    begin
      PrintHelp;
      Halt(0);
    end
    else
    begin
      Writeln('Unknown command option');
      Writeln('Type "-?" for help.');
      Halt(1);
    end;
  end;
end;

procedure a;
begin
  setfillstyle(1, 8);
  for i := 1 to 32 do
    for j := 1 to 32 do
      if (map[i][j] > 0) then
      bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);
end;

begin
  L := 0;
  R := 0;
  F := 0;
  B := 0;
  xp := 2048;
  yp := 2048;
  Angle_P := 0;

  CheckCommandLine(ParamCount + 1, ParamStr(1), ParamStr(2));
  Load;
  SetMode($13);
  SetPal;
  FillTables;

  repeat
    tx := xp;
    ty := yp;

    Key := Port[$60];

    case Key of
       80: begin B := 1; F := 0; end;
       72: begin F := 1; B := 0; end;
       77: begin R := 1; L := 0; end;
       75: begin L := 1; R := 0; end;
      208: begin B := 0; F := 0; end;
      200: begin F := 0; B := 0; end;
      205: begin R := 0; L := 0; end;
      203: begin L := 0; R := 0; end;
    end;

    if B = 1 then
    begin
      Inc(tx, Trunc(Sin((Angle_P - 90) * Pi / 180) * 16));
      Inc(ty, Trunc(Cos((Angle_P - 90) * Pi / 180) * 16));
    end;
    if F = 1 then
    begin
      Dec(tx, Trunc(Sin((Angle_P - 90) * Pi / 180) * 16));
      Dec(ty, Trunc(Cos((Angle_P - 90) * Pi / 180) * 16));
    end;

    if R = 1 then Inc(Angle_P, 2);
    if L = 1 then Dec(Angle_P, 2);

    xp := tx;
    yp := ty;

    if (tx mod 128 > 64) and (Map[tx div 128 + 2][ty div 128 + 1] > 0) then
    begin
      xp := tx div 128 * 128 + 64;
      tx := xp;
      yp := ty;
    end
    else
    if (tx mod 128 < 64) and (Map[tx div 128][ty div 128 + 1] > 0) then
    begin
      xp := tx div 128 * 128 + 64;
      tx := xp;
      yp := ty;
    end;
    if (ty mod 128 > 64) and (Map[tx div 128 + 1][ty div 128 + 2] > 0) then
    begin
      yp := ty div 128 * 128 + 64;
      ty := yp;
      xp := tx;
    end
    else
    if (ty mod 128 < 64) and (Map[tx div 128 + 1][ty div 128] > 0) then
    begin
      yp := ty div 128 * 128 + 64;
      ty := yp;
      xp := tx;
    end;

    if Angle_P > 359 then Angle_P := 0;
    if Angle_P < 0 then Angle_P := 359;

    if InFlag = 1 then
    begin
      Read(In_, xp, yp, Angle_P);
      if Eof(In_) then
      begin
        Close(In_);
        Assign(In_, ParamStr(2));
        Reset(In_);
      end;
    end;

    for i := 0 to 319 do
    begin
      Angle := ((Angle_P - 30) * 53 + i * 10) div 10;
      if Angle < 0 then Inc(Angle, 1920);
      if Angle > 1920 then Dec(Angle, 1920);
      D := Dist(Angle, xp, yp);
      if D > 0 then
      begin
        M := Trunc(32768 / (D * CosTable[i + 1]));
        if M > 200 then
          PutLine(i, 0, M, 199, TexOff, M)
        else
          PutLine(i, 100 - M div 2, 100 + M div 2, 80, TexOff, M);
      end;
    end;

    asm
        cli
        mov    ax,  0C00h
        int    21h
        sti
    end;

    if OutFlag = 1 then
    begin
      Writeln(Out, xp, ' ', yp, ' ', Angle_P);
    end;

  until Key = 1;

  SetMode($3);
  if Outflag = 1 then Close(Out);
  if Inflag = 1 then Close(In_);
  Writeln('Copyright (c) 1999 by MATI Inc.');
end.

